Index: channels/chan_sip.c
===================================================================
--- channels/chan_sip.c	(revision 313524)
+++ channels/chan_sip.c	(working copy)
@@ -6179,7 +6191,10 @@
 	}
 	p = newchan->tech_pvt;
 
-	sip_pvt_lock(p);
+	while (sip_pvt_trylock(p)) {
+		CHANNEL_DEADLOCK_AVOIDANCE(oldchan);
+	}
+
 	append_history(p, "Masq", "Old channel: %s\n", oldchan->name);
 	append_history(p, "Masq (cont)", "...new owner: %s\n", newchan->name);
 	if (p->owner != oldchan)
